CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     RAM-based Spin Interpreter Test - Step 8                                  RamVm_Step8.spin      *
' *                                                                                                     *
' *******************************************************************************************************

PRI Version

  result := String( "RamVm_Step8" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

  TV_PIN        = 12
  
  LED_PIN       = 9

OBJ

  RamInterpreter : "RamVm_Step8_Interpreter"

  tv             : "TV_Text"
    
VAR

  long number

  long priStack[ 1000 ]
  long subStack[ 1000 ]
  
PUB Main( running )

  if not running
    running := true
    RamInterpreter.Start

  tv.Start( TV_PIN )

  CogNew( PriSpinCode, @priStack )
  
  repeat
    tv.Out( $01 )
    tv.Str( Version )
    tv.Out( $0D )
    tv.Dec( number )

PRI PriSpinCode

  CogNew( SubSpinCode, @subStack )
  
  DIRA[ LED_PIN ] := 1
  repeat
    number++
    ! OUTA[ LED_PIN ]
    PauseMs( 250 )

PRI SubSpinCode

  repeat
    number++
    PauseMs( 250 )
  
PRI PauseMs( ms )

  waitcnt( CLKFREQ / 1000 * ms + CNT )